from jnpr.junos import Device
#from jnpr.junos.utils.config import Config
from jnpr.junos.exception import *
import sys
import argparse
parser = argparse.ArgumentParser(description='This is a helper script by Ciaran.')
parser.add_argument('-d','--device', help='Host IP', required=False)
args = parser.parse_args()
devlist = ['172.30.100.10','172.30.101.10','172.30.102.10','172.30.105.10','172.30.106.10','172.30.107.10','172.30.108.10','172.30.109.10','172.30.110.10','172.30.111.10','172.30.112.10','172.30.113.10','172.30.114.10','10.0.47.116.10','172.30.117.10','172.30.118.10','172.30.119.10','172.30.120.10','172.30.121.10','172.30.122.10','172.30.123.10','172.30.124.10','172.30.125.10','172.30.127.10','172.30.132.10','172.30.133.10','172.30.134.10','172.30.135.10','172.30.136.10','172.30.137.10','172.30.138.10','172.30.140.10','172.30.141.10','172.30.165.10','172.30.166.10','172.30.167.10']

def get_trunk_ports(device):
    user = 'Ckendellen'
    passwd = 'h2VEF4e2'
    sys.stdout.write('connecting to %s ...' % device)
    sys.stdout.flush()
    dev = Device(device,user=user,password=passwd)
    dev.open()
    print('ok')
    switchinfo = dev.rpc.get_software_information()
    try:
        hostname =  switchinfo.getchildren()[0].getchildren()[1]
        print hostname.findtext('host-name')
    except Exception as err:
        try:
            print switchinfo.findtext('host-name')
        except Exception as err:
             print('Couldn\'t find host name...')
    interfaces = dev.rpc.get_interface_information()
    for interface in interfaces.getiterator('physical-interface'):
      if interface.findtext('oper-status') == '\nup\n':
          logical = interface.find('logical-interface')
          if logical is not None:
              family = logical.find('address-family')
              if family is not None:
                  flags = family.find('address-family-flags')
                  if flags is not None:
                          mode = flags.find('ifff-port-mode-trunk')
                          if mode is not None:# this IS a trunk port...
                              print interface.findtext('name').strip().ljust(10), interface.findtext('description').strip()#.rjust(12), vlan.findtext('interface-vlan-member-tagid').rjust(5), vlan.findtext('interface-vlan-name').ljust(32), vlan.findtext('blocking-status').rjust(14)
    dev.close()

if not args.device:
    for device in devlist:
      get_trunk_ports(device)
else:
    get_trunk_ports(args.device)
print('All done!')

